#include "WinFuncs.inc"


'EXTRAS:

  % DM_SPECVERSION 0x0400
  % DM_SPECVERSION 0x0320
  '
  % DM_ORIENTATION          0x00000001L
  % DM_PAPERSIZE            0x00000002L
  % DM_PAPERLENGTH          0x00000004L
  % DM_PAPERWIDTH           0x00000008L
  % DM_SCALE                0x00000010L
  % DM_POSITION             0x00000020L
  % DM_NUP                  0x00000040L
  % DM_DISPLAYORIENTATION   0x00000080L
  % DM_COPIES               0x00000100L
  % DM_DEFAULTSOURCE        0x00000200L
  % DM_PRINTQUALITY         0x00000400L
  % DM_COLOR                0x00000800L
  % DM_DUPLEX               0x00001000L
  % DM_YRESOLUTION          0x00002000L
  % DM_TTOPTION             0x00004000L
  % DM_COLLATE              0x00008000L
  % DM_FORMNAME             0x00010000L
  % DM_LOGPIXELS            0x00020000L
  % DM_BITSPERPEL           0x00040000L
  % DM_PELSWIDTH            0x00080000L
  % DM_PELSHEIGHT           0x00100000L
  % DM_DISPLAYFLAGS         0x00200000L
  % DM_DISPLAYFREQUENCY     0x00400000L
  % DM_ICMMETHOD            0x00800000L
  % DM_ICMINTENT            0x01000000L
  % DM_MEDIATYPE            0x02000000L
  % DM_DITHERTYPE           0x04000000L
  % DM_PANNINGWIDTH         0x08000000L
  % DM_PANNINGHEIGHT        0x10000000L
  % DM_DISPLAYFIXEDOUTPUT   0x20000000L

  /* Flags for ChangeDisplaySettings */
  % CDS_UPDATEREGISTRY           0x00000001
  % CDS_TEST                     0x00000002
  % CDS_FULLSCREEN               0x00000004
  % CDS_GLOBAL                   0x00000008
  % CDS_SET_PRIMARY              0x00000010
  % CDS_VIDEOPARAMETERS          0x00000020
  % CDS_ENABLE_UNSAFE_MODES      0x00000100
  % CDS_DISABLE_UNSAFE_MODES     0x00000200
  % CDS_RESET                    0x40000000
  % CDS_NORESET                  0x10000000

  /* Return values for ChangeDisplaySettings */

  % DISP_CHANGE_SUCCESSFUL       0
  % DISP_CHANGE_RESTART          1
  % DISP_CHANGE_FAILED          -1
  % DISP_CHANGE_BADMODE         -2
  % DISP_CHANGE_NOTUPDATED      -3
  % DISP_CHANGE_BADFLAGS        -4
  % DISP_CHANGE_BADPARAM        -5
  % DISP_CHANGE_BADDUALVIEW     -6

  ' PIXELFORMATDESCRIPTOR flags

  % PFD_TYPE_RGBA       = 0
  % PFD_TYPE_COLORINDEX = 1
  % PFD_MAIN_PLANE      = 0
  % PFD_OVERLAY_PLANE   = 1
  % PFD_UNDERLAY_PLANE  =-1
  '
  % PFD_DOUBLEBUFFER          = &H00000001
  % PFD_STEREO                = &H00000002
  % PFD_DRAW_TO_WINDOW        = &H00000004
  % PFD_DRAW_TO_BITMAP        = &H00000008
  % PFD_SUPPORT_GDI           = &H00000010
  % PFD_SUPPORT_OPENGL        = &H00000020
  % PFD_GENERIC_FORMAT        = &H00000040
  % PFD_NEED_PALETTE          = &H00000080
  % PFD_NEED_SYSTEM_PALETTE   = &H00000100
  % PFD_SWAP_EXCHANGE         = &H00000200
  % PFD_SWAP_COPY             = &H00000400
  % PFD_SWAP_LAYER_BUFFERS    = &H00000800
  % PFD_GENERIC_ACCELERATED   = &H00001000
  % PFD_SUPPORT_DIRECTDRAW    = &H00002000

  ' PIXELFORMATDESCRIPTOR flags for use in ChoosePixelFormat only
  % PFD_DEPTH_DONTCARE        = &H20000000
  % PFD_DOUBLEBUFFER_DONTCARE = &H40000000
  % PFD_STEREO_DONTCARE       = &H80000000

  /*
  * System Menu Command Values
  */

  % SC_SIZE         0xF000
  % SC_MOVE         0xF010
  % SC_MINIMIZE     0xF020
  % SC_MAXIMIZE     0xF030
  % SC_NEXTWINDOW   0xF040
  % SC_PREVWINDOW   0xF050
  % SC_CLOSE        0xF060
  % SC_VSCROLL      0xF070
  % SC_HSCROLL      0xF080
  % SC_MOUSEMENU    0xF090
  % SC_KEYMENU      0xF100
  % SC_ARRANGE      0xF110
  % SC_RESTORE      0xF120
  % SC_TASKLIST     0xF130
  % SC_SCREENSAVE   0xF140
  % SC_HOTKEY       0xF150
  % SC_DEFAULT      0xF160
  % SC_MONITORPOWER 0xF170
  % SC_CONTEXTHELP  0xF180
  % SC_SEPARATOR    0xF00F

  % SCF_ISSECURE    0x00000001


  /*
  * Extended Window Styles
  */

  % WS_EX_DLGMODALFRAME     0x00000001
  % WS_EX_NOPARENTNOTIFY    0x00000004
  % WS_EX_TOPMOST           0x00000008
  % WS_EX_ACCEPTFILES       0x00000010
  % WS_EX_TRANSPARENT       0x00000020
  
  % WS_EX_MDICHILD          0x00000040
  % WS_EX_TOOLWINDOW        0x00000080
  % WS_EX_WINDOWEDGE        0x00000100
  % WS_EX_CLIENTEDGE        0x00000200
  % WS_EX_CONTEXTHELP       0x00000400

  % WS_EX_RIGHT             0x00001000
  % WS_EX_LEFT              0x00000000
  % WS_EX_RTLREADING        0x00002000
  % WS_EX_LTRREADING        0x00000000
  % WS_EX_LEFTSCROLLBAR     0x00004000
  % WS_EX_RIGHTSCROLLBAR    0x00000000

  % WS_EX_CONTROLPARENT     0x00010000
  % WS_EX_STATICEDGE        0x00020000
  % WS_EX_APPWINDOW         0x00040000

  % WS_EX_OVERLAPPEDWINDOW  (WS_EX_WINDOWEDGE | WS_EX_CLIENTEDGE)
  % WS_EX_PALETTEWINDOW     (WS_EX_WINDOWEDGE | WS_EX_TOOLWINDOW | WS_EX_TOPMOST)

  % WS_EX_LAYERED           0x00080000

  % WS_EX_NOINHERITLAYOUT   0x00100000 // Disable inheritence of mirroring by children
  % WS_EX_LAYOUTRTL         0x00400000 // Right to left mirroring

  % WS_EX_COMPOSITED        0x02000000

  % WS_EX_NOACTIVATE        0x08000000

  % DEFAULT_QUALITY        = 0
  % DRAFT_QUALITY          = 1
  % PROOF_QUALITY          = 2
  % NONANTIALIASED_QUALITY = 3
  % ANTIALIASED_QUALITY    = 4

  % IDI_APPLICATION     32512
  % IDC_ARROW           32512
  % IDI_HAND            32513
  % IDI_QUESTION        32514
  % IDI_EXCLAMATION     32515
  % IDI_ASTERISK        32516
  % IDI_WINLOGO         32517
  % IDI_SHIELD          32518


  declare ChangeDisplaySettings lib "user32.dll" alias "ChangeDisplaySettingsA" (dm as DEVMODE,byval dwFlags as dword) as long

  '---------------------------------
  function hiword   (long a) as long
  '=================================
  shr a,16 : function=a
  end function

  '------------------------------
  function loword(long a) as long
  '==============================
  and a,&hffff : function=a
  end function


