#COMPILE EXE
#DIM ALL

INTERFACE InterfaceA
  INHERIT IUNKNOWN                            '0 1 2
  PROPERTY GET MyProp() AS LONG               '3
  PROPERTY SET MyProp(BYVAL v AS LONG)        '4
  METHOD   MyMethod(BYVAL v AS LONG) AS LONG  '5
END INTERFACE

'DECLARE FUNCTION MethNoArgs   (BYREF a AS InterfaceA, BYVAL v AS LONG) AS LONG
'DECLARE FUNCTION MethLongArg1 (BYREF a AS InterfaceA, BYVAL v AS LONG) AS LONG

FUNCTION PBMAIN () AS LONG
'=========================
'
DIM po      AS LONG PTR   'pointer to interface
DIM pt      AS LONG PTR   'pointer to function table
DIM pv      AS LONG PTR   'pointer to interface body (properties etc)
DIM iao(32) AS LONG       'interface body space
DIM vt(100) AS LONG       'function table space
DIM v       AS LONG       'temp variable
DIM w       AS LONG       'temp variable
DIM ia      AS InterfaceA 'interface
'
'SETUP
'=====
'
pt=VARPTR(vt(0))
po=VARPTR(ia)
pv=VARPTR(iao(0))
@pv=pt 'assign vft
@po=pv 'assign body
'iunknown
@pt[0]=CODEPTR(qi) 'QueryInterface
@pt[1]=CODEPTR(qa) 'AddRef
@pt[2]=CODEPTR(qr) 'Release
'interfaceA methods
@pt[3]=CODEPTR(m1) 'GetMyProp
@pt[4]=CODEPTR(m2) 'SetMyProp
@pt[5]=CODEPTR(m3) 'MyMethod
'
'TESTS
'=====

'CALL DWORD @@@po[3] USING MethLongArg1 (ia,42) TO v
ia.MyProp=123
v=ia.MyProp
w=ia.MyMethod(21)
MSGBOX(STR$(v)+"  "+STR$(w))
EXIT FUNCTION

'INTERFACE A methods
'===================

qi: 'QueryInterface
'ignore guid
! mov edx,[esp+12] 'interface address (byref)
! mov ecx,pv       'assign body
! mov [edx],ecx
! mov eax,pt       'assign table
! mov [ecx],eax
! mov eax,0        'null error code
! ret 12

qa: 'Addref
'==========
'no action
! mov eax,0
! ret 4

qr: 'Release
'===========
'no action
! mov eax,0
! ret 4

m1: 'GetMyProp
'=============
! mov ecx,po
! mov eax,[ecx+8] 'from property variable X
! ret 4

m2: 'SetMyProp
'=============
! mov eax,[esp+8]
! mov ecx,po
! mov [ecx+8],eax  'to property variable X
! ret 8

m3: 'MyMethod
'============
! mov eax,[esp+8]
! shl eax,1 'double number
! ret 8

END FUNCTION
