type vector float x,y,z

macro vector_op(a,b,c,d)
  '
  macro .op(a,b,c,d)
  a.x=b.x d c.x
  a.y=b.y d c.y
  a.z=b.z d c.z
  end macro
  '
  macro ."str" string (a,b)
  float xx,yy,zz
  a=str(b.x)+","+str(b.y)+","+str(b.z)
  end macro
  '
  macro ."print"(a,b)
  print " " +str(b.x)+","+str(b.y)+","+str(b.z)
  end macro
  '
  macro .cond(a,b,c,d)
  scope
  double aa=a.x*a.x+a.y*a.y+a.z*a.z
  double bb=b.x*b.x+b.y*b.y+b.z*b.z
  if aa c bb  then d = 1
  end scope
  end macro
  '
  macro ."load"(a)
  end macro
  '
  macro ."save"(a,b)
  a.x=b.x
  a.y=b.y
  a.z=b.z
  end macro
  '
  macro ."neg"(a,b)
  a.x=-b.x
  a.y=-b.y
  a.z=-b.z
  end macro
  '
  macro ."+"(a,b,c)
  vector_op.op(a,b,c,+)
  end macro
  '
  macro ."-"(a,b,c)
  vector_op.op(a,b,c,-)
  end macro
  '
  macro ."*"(a,b,c)
  vector_op.op(a,b,c,*)
  end macro
  '
  macro ."/"(a,b,c)
  vector_op.op(a,b,c,/)
  end macro
  '
  '
  macro .">" bool (a,b,c)
  vector_op.cond(b,c,>,a)
  end macro

  macro ."<" bool (a,b,c)
  vector_op.cond(b,c,<,a)
  end macro

  macro .">=" bool (a,b,c)
  vector_op.cond(b,c,>=,a)
  end macro
  '
  macro ."<=" bool (a,b,c)
  vector_op.cond(b,c,<=,a)
  end macro
  '
  macro ."=" bool (a,b,c)
  vector_op.cond(b,c,=,a)
  end macro
  '
  macro ."<>" bool (a,b,c)
  vector_op.cond(b,c,<>,a)
  end macro
  '
end macro
