'Program Name Form2.bas
'#Compile Exe
'#Include "Win32api.inc"  'Equates, declares, types translated from Windows.h

macro executable(name,width)
% Filename name
#if (width=64)
  include "$\inc\RTL64.inc"
#else
  include "$\inc\RTL32.inc"
#endif
end macro

generate

include "$\inc\minwin.inc"

%HWND_DESKTOP 0
%MK_LBUTTON   1

'BOOL TextOut(
'  _In_  HDC hdc,
'  _In_  int nXStart,
'  _In_  int nYStart,
'  _In_  LPCTSTR lpString,
'  _In_  int cchString
');

macro trim(s)
ltrim(s)
end macro

macro lowrd(a)
a and 0xffff
end macro

macro hiwrd(a)
a >> 16 and 0xffff
end macro

macro codeptr(c)
@c
end macro

macro varptr(v)
@v
end macro

macro DimAsciiz(name,size)
char name[size]
end macro

macro GoWinMain()
char *c
sys h
@c=GetCommandline()
h=GetModuleHandle()
WinMain(h,0,c,SW_SHOWNORMAL)
end macro

type tagMSG
  sys   hwnd
  int   message
  sys   wParam
  sys   lParam
  dword time
  POINT pt
end type

type TEXTMETRIC
  LONG  tmHeight;
  LONG  tmAscent;
  LONG  tmDescent;
  LONG  tmInternalLeading;
  LONG  tmExternalLeading;
  LONG  tmAveCharWidth;
  LONG  tmMaxCharWidth;
  LONG  tmWeight;
  LONG  tmOverhang;
  LONG  tmDigitizedAspectX;
  LONG  tmDigitizedAspectY;
  TCHAR tmFirstChar;
  TCHAR tmLastChar;
  TCHAR tmDefaultChar;
  TCHAR tmBreakChar;
  BYTE  tmItalic;
  BYTE  tmUnderlined;
  BYTE  tmStruckOut;
  BYTE  tmPitchAndFamily;
  BYTE  tmCharSet;
end type

'#recordof textmetric


! TextOut          lib "gdi32.dll"  alias "TextOutA"         (sys hDC,long x,y,char*s,long len)
! GetTextMetrics   lib "gdi32.dll"  alias "GetTextMetricsA"  (sys hDC,TEXTMETRIC*tm)
! BeginPaint       lib "user32.dll" alias "BeginPaint"       (sys hWnd,PAINTSTRUCT*ps)
! EndPaint         lib "user32.dll" alias "EndPaint"         (sys hWnd,PAINTSTRUCT*ps)
! RegisterClassEx  lib "user32.dll" alias "RegisterClassExA" (WndClassEx*wc)
! GetMessage       lib "user32.dll" alias "GetMessageA"      (tagMsg*m,sys a,b,c)
! TranslateMessage lib "user32.dll" alias "TranslateMessage" (tagMsg*m)
! DispatchMessage  lib "user32.dll" alias "DispatchMessageA" (tagMsg*m)


