
  include "$/inc/minwin.inc"
  indexbase 1

  extern lib "kernel32.dll"
  ! WriteConsole    alias "WriteConsoleA"    (sys hConsoleOutput, lpBuffer, nNumberOfCharsToWrite, *lpNumberOfCharsWritten, lpReserved) as sys
  ! ReadConsole     alias "ReadConsoleA"     (sys hConsoleInput,lpBuffer,nNumberOfCharsToRead, *lpNumberOfCharsRead, *pInputControl) as sys
  ! SetConsoleTitle alias "SetConsoleTitleA" (char*lpConsoleTitle) as sys
  ! GetConsoleTitle alias "GetConsoleTitleA" (char*ct,sys le) as sys
  end extern

  %STD_INPUT_HANDLE  = -10
  %STD_OUTPUT_HANDLE = -11
  %STD_ERROR_HANDLE  = -12

  include "SbBES.inc"

  string cr=chr(13,10)
  string tab=chr(9)



  function ExePath() as string
  ============================
  char s[256]
  byte *b=strptr s
  GetModuleFileName 0,@b,256
  sys i
  do
    select b
    case 0  : exit do
    case 92 : i=@b
    end select
    @b++
  end do
  return left s,i-strptr(s)+1 'includes final slash
  end function

  function newmem cdecl (sys le) as sys, external
  ===============================================
  return getmemory le
  end function

  sub freemem cdecl (sys p) external
  ==================================
  freememory p
  end sub 

  function CloseThread(sys thr)
  =============================
  CloseHandle thr 'thread handle
  end function

  function StartSbThread(sys*dat) external 
  ========================================
  SupportTable t at (dat[1])
  SbData ArgData[2],ReturnData
  ArgData[1].typ=SBT_LONG 'DOUBLE 'STRING 'ZCHAR
  ArgData[1].gen=dat[4] 'msg
  ArgData[2].typ=SBT_LONG
  ArgData[2].gen=dat[5] 'idat
  '
  t.scriba_CallArgEx(dat[2],dat[3],@ReturnData,2,@ArgData)
  t.scriba_destroy dat[2] 'pProgram
  freememory @dat 'release param block
  end function 'start thread function
  '
  function StartSbProg(sys pst, string fi,sys*pProgram) as sys
  ============================================================
  sys er
  SupportTable t at pst
  pProgram=t.scriba_new @newmem, @freemem
  t.scriba_SetFileName pProgram,fi
  er=t.scriba_LoadSourceProgram pProgram
  if er 
    print "Problem loading source program " fi "  " er
    jmp fwd done
  end if
  er=t.scriba_Run pProgram,""
  if er
    print "Problem running program " fi " " er
    jmp fwd done
  end if
  return er
  done:
  t.scriba_destroy pProgram
  return er
  end function

  function EndSbProg(sys pst, pProgram) as sys
  ==============================================
  SupportTable t at pst
  t.scriba_destroy pProgram
  end function


  function CallSbProc(sys pst, pProgram,char*func,sys n, *va) as sys
  ==================================================================
  SupportTable t at pst
  SbData       ReturnData,ArgData[8]
  sys          i,e,p,er,fa
  string       fas
  '
  if func="" then jmp fwd done
  '
  fas=lcase func 'all lowercase
  fa=t.scriba_LookupFunctionByName pProgram,fas
  '
  if fa=0
    'print "problem with function " fas "  " fa
    jmp fwd done
  end if
  '
  'setup args
  '
  for i=1 to n
    ArgData[i].typ=SBT_LONG 'DOUBLE 'STRING 'ZCHAR
    ArgData[i].gen=va[i]
  next
  '
  er=t.scriba_CallArgEx pProgram, fa, @ReturnData, n, @ArgData
  '
  if er
    print er
    jmp fwd done
  end if
  '
  'READ RETURNED VALUE
  '-------------------
  '
  if ReturnData.typ
    'pr=""
    'select case ReturnData.typ
    '  case SBT_UNDEF  : pr+= "Undefined "
    '  case SBT_DOUBLE : pr+="double "  ReturnData.dbl
    '  case SBT_LONG   : pr+="long "    ReturnData.lng
    '  case SBT_STRING : pr+="zstring " ReturnData.str
    '  case SBT_ZCHAR  : pr+="zchar "   ReturnData.str
    'end select
    'pr+=cr
    'print pr
    return ReturnData.lng
  end if
  done:
  end function

  function RunSbProg(sys pst, string fi,func,sys thread,idat, *pprog) as sys
  ==========================================================================
  'putfile "t.txt",recordof _SupportTable
  SbData ReturnData,ArgData[3]
  sys p,n,er,fa
  SupportTable t at pst
  '
  if StartSbProg(pst,fi,pProg)
    jmp fwd done
  end if
  '
  if thread=0
    sys a[2]={pProg,idat}
    function=callSbProc(pst,pProg,func,2,a)
    t.scriba_destroy pProg
    exit function
  end if
  '  
  if func="" then jmp fwd done
  '
  string fas=lcase func 'all lowercase
  fa=t.scriba_LookupFunctionByName pProg,fas
  if fa=0
    print "problem with function " fas "  " fa
    jmp fwd done
  end if
  if thread then
    sys dat at (getmemory 8*sizeof sys) 'heapspace
    dat={pst, pProg, fa, pProg,idat}
    dat[6]=CreateThread 0, 0, @StartSbThread, @dat, 0, 0
    return dat[6]
  end if 'thread
  done:
  end function



'STPG
'ENPG
'CLBK  get callback handle
'CALT/COBT  transfer to a thread
'CLOS  terminate a thread


  function GetStringParamA(sys pst,pm) as string
  =============================================
  SupportTable  t at (pst)
  ExecuteObject e at (*pst)
  sys p,le
  p=t.Convert2String e, pm, e.pGlobalMortalList
  le=*(p+8) 'length of string
  'function=nuls le 
  'copy strptr function,*p,le
  zstring pz at *p
  return pz 'autoconverts to dynamic string
  end function

  function GetStringParam(sys pst,pm) as string
  =============================================
  sys c,p,le
  c=*(pst+0xf4) 'Convert2String
  p=*pst
  p=call c p, pm, *(p+0x8c)
  le=*(p+8) 'length of string
  function=nuls le 
  copy strptr function,*p,le
  'zstring pz at *p
  'return pz 'autoconverts to dynamic string
  end function


  function GetPtrStringParam(sys pst,pm) as sys
  =============================================
  sys c,p
  c=*(pst+0xf4) 'Convert2String
  p=*pst
  p=call c p, pm, *(p+0x8c)
  return *p
  end function


  function GetDatStringParam(sys pst,pm) as string
  ================================================
  sys c,p,le
  c=*(pst+0xf4) 'Convert2String
  p=*pst
  p=call c p, pm, *(p+0x8c)
  le=*(p+8) 'length of string
  string s=nuls le
  copy strptr s,*p,le
  return s
  end function


  function GetPtrDatStringParam(sys pst,pm,*le) as sys
  ====================================================
  sys c,p,le
  c=*(pst+0xf4) 'Convert2String
  p=*pst
  p=call c p, pm, *(p+0x8c)
  le=*(p+8) 'length of string
  return *p 'base address of string
  end function


  function PutStringParam(sys pst,pm,string s)
  ============================================
  sys c,p
  c=*(pst+0xf4) 'Convert2String
  p=*pst
  p=call c p, pm, *(p+0x8c)
  zstring pz at *p
  pz=s
  end function


  function GetLongParam(sys pst,pm) as long
  =========================================
  sys c,p
  c=*(pst+0xf8) 'Convert2Long
  p=*pst
  'pFixSizeMemoryObject (*Convert2Long)(pExecuteObject, pFixSizeMemoryObject, pMortalList);
  p=call c p, pm, *(p+0x8c)
  return *p
  end function


  function GetPtrLongParam(sys pst,pm) as sys
  ===========================================
  sys c,p
  c=*(pst+0xf8) 'Convert2Long
  p=*pst
  return call c p, pm, *(p+0x8c)
  end function


  function PutLongParam(sys pst,pm, sys v)
  ========================================
  sys c,p
  c=*(pst+0xf8) 'Convert2Long
  p=*pst
  p=call c p, pm, *(p+0x8c)
  *p=v
  end function


  function GetDoubleParam(sys pst,pm) as double
  =============================================
  sys c,p
  c=*(pst+0xfc) 'convert2double
  p=*pst
  p=call c p, pm, *(p+0x8c)
  double pd at p
  return pd
  end function


  function GetPtrDoubleParam(sys pst,pm) as sys
  =============================================
  sys c,p
  c=*(pst+0xfc) 'convert2double
  p=*pst
  return call c p, pm, *(p+0x8c)
  end function


  function PutDoubleParam(sys pst,pm,double d)
  ============================================
  sys c,p
  c=*(pst+0xfc) 'convert2double
  p=*pst
  p=call c p, pm, *(p+0x8c)
  double pd at p
  pd=d
  end function


  function ReturnString(sys pst,string s) as sys
  ==============================================
  sys c,p,ls
  ls=len(s)
  c=*(pst+0x0c) 'NewMortalString
  p=*pst
  p=call c *(p+0x94),ls, *(p+0x8c)
  copy *p,strptr s,ls
  return p
  end function


  function ReturnZstring(sys pst,char*s) as sys
  =============================================
  sys c,p,ls
  ls=len(s)
  c=*(pst+0x0c) 'NewMortalString
  p=*pst
  p=call c *(p+0x94),ls, *(p+0x8c)
  copy *p,strptr s,ls
  return p
  end function


  function ReturnData(sys pst,ad,le) as sys
  =========================================
  sys c,p
  c=*(pst+0x0c) 'NewMortalString
  p=*pst
  p=call c *(p+0x94),le, *(p+0x8c)
  copy *p,ad,le
  return p
  end function


  function ReturnLong(sys pst,Long v) as sys
  ==========================================
  sys c,p
  c=*(pst+0x10) 'NewMortalLong
  p=*pst
  p=call c *(p+0x94), *(p+0x8c)
  long pv at p
  pv=v
  return p
  end function


  function ReturnRef(sys pst,sys v) as sys
  ========================================
  sys c,p
  c=*(pst+0x14) 'NewMortalRef
  p=*pst
  p=call c *(p+0x94), *(p+0x8c)
  sys pv at p
  pv=v
  return p
  end function


  function ReturnDouble(sys pst,double d) as sys
  ==============================================
  sys c,p
  c=*(pst+0x18) 'NewMortalDouble
  p=*pst
  p=call c *(p+0x94), *(p+0x8c)
  double pd at p
  pd=d
  return p
  end function


  function CreateArray(sys pst,x,y) as sys
  ========================================
  sys c,p
  c=*(pst+0x1C) 'NewMortalArray
  p=*pst
  return call c *(p+0x94), *(p+0x8c), x, y
  'c=*(pst+0x30) 'NewArray
  'return call c *(p+0x94), x, y
  end function


  function GetParamPtr(sys pParams, pn) as sys
  ============================================
  return *(*pParams+pn*4-4) 'pointer to parameter
  end function
 

  extern export
  =============


  function versmodu cdecl (sys Version, pszVariation, ppModuleInternal) as sys
  ============================================================================
  'print "Version: " hex version
  return Version
  end function


  function bootmodu cdecl (sys pSt, ppModuleInternal, pParameters, pReturnValue) as sys
  =====================================================================================
  'print "Boot!"
  end function


  function finimodu cdecl (sys pSt, ppModuleInternal, pParameters, pReturnValue) as sys
  =====================================================================================
  'print "Finish!"
  end function

end extern


  macro CountParams(pParameters,c)
  ================================
  c=*(pParameters+8) >> 2
  end macro


  sub skiplspace(string s, sys*i)
  '==============================
  sys a
  if i>len(s) then exit sub
  do
    a=asc s,i
    select a
    case 0,13,10, 33 to 255 : exit do
    end select
    i++
  end do
  end sub


  function getword(string ss,sys*b) as string
  '==========================================
  if b=0 then b=1
  if not len ss then exit function
  byte s at strptr ss
  byte c,d
  sys bb,bc
  a=0
  bb=b
  '
  'SKIP LEADING SPACES
  do
    c=s[b]
    select c
    case 33 to 255,0 : exit do 'SKIP SPACE
    end select
    b++
  end do
  bc=b
  '
  'QUOTES
  select c
  case 34,39
   do
      b+=1
      d=s[b]
      if d=0 or d=c then b+=1 : jmp fwd done
   end do
  end select
  'WORDS AND SYMBOLS
  do
    c=s[b]
    select c
    case 0 to 32    : exit do
    case 35         : jmp fwd more
    case 33 to 47   : 'symbols
    case 48 to 57   : jmp fwd more 'numbers
    case 58 to 64   : 'symbols
    case 65 to 90   : jmp fwd more 'capitals
    case 95         : jmp fwd more 'underscore
    case 91 to 96   : 'symbols
    case 97 to 122  : jmp fwd more 'lower case
    case 123 to 127 : 'symbols
    case 128 to 255 : jmp fwd more 'higher ascii
    end select
    '
    '
    if b=bc then b++
    exit do
    '
    more:
    b++
  end do
  '
  done:
  '
  if b>bb then
    return mid ss,bc,b-bc
  end if
  end function

