' /* SIMPLE WINDOW LIBRARY FOR OXYGEN BASIC BY PETER WIRBELAUER  1o.o2.2o13  */

sw=dllfile("sw.dll")
MakeDir       = dllproc( sw,"MakeDir (c* dirName)")
LoadBytes     = dllproc( sw,"LoadBytes i=(c* nName,t*Destination as any)" )
SaveBytes     = dllproc( sw,"SaveBytes i=(c* nName,t*Destination as any, i count)" )
FileExits     = dllproc( sw,"FileExits i=(c* nName)" )
FilePointer   = dllproc( sw,"FilePointer i=( i FileHandle,count)" )
OpenFile      = dllproc( sw,"OpenFile i=(c* nName)" )
FileSize      = dllproc( sw,"FileSize i=( i FileHandle)" )
CloseFile     = dllproc( sw,"CloseFile i=( i FileHandle)" )
ReadByte      = dllproc( sw,"ReadByte i=( i FileHandle, t*Destination, i count)" )
ReadInt       = dllproc( sw,"ReadInt i=( i FileHandle, t*Destination, i count)" )
ReadLong      = dllproc( sw,"ReadLong i=( i FileHandle, t*Destination, i count)" )
WriteByte     = dllproc( sw,"WriteByte i=( i FileHandle, t*Destination, i count)" )
WriteInt      = dllproc( sw,"WriteInt i=( i FileHandle, t*Destination, i count)" )
WriteLong     = dllproc( sw,"WriteLong i=( i FileHandle, t*Destination, i count)" )
DeleteFile    = dllproc( sw,"DeleteFile i=(c* FileName)" )

PlayWav       = dllproc( sw,"PlayWav i=(c* wavFile)" )
StopWav       = dllproc( sw,"StopWav() " )
SetFont       = dllproc( sw,"SetFont i=( i width,i height,i style,c* fontName)" )
SetText       = dllproc( sw,"SetText i=( i xPos, i yPos,c* text, i color)" )
LoadIcon      = dllproc( sw,"LoadIcon i=(c* iconFile)" )
DrawIcon      = dllproc( sw,"DrawIcon i=( i iconId, i xPos, i yPos,i xZoom,i yZoom,i Frames)" )
yMouse        = dllproc( sw,"yMouse i=()" ) 
xMouse        = dllproc( sw,"xMouse i=()" )
MouseButton   = dllproc( sw,"MouseButton i=()" )
WaitMouse     = dllproc( sw,"WaitMouse i=()" )
ShowMouse     = dllproc( sw,"ShowMouse i=( i value)" )
MouseZone     = dllproc( sw,"MouseZone i=( i xPos,i yPos,i width,i height)" )
SetFps        = dllproc( sw,"SetFps i=( i frames)" )
ShowFps       = dllproc( sw,"ShowFps i=()" )
Key           = dllproc( sw,"Key s=( i mKey) as integer " )
GetKey        = dllproc( sw,"GetKey i=()" )
WaitKey       = dllproc( sw,"WaitKey i=()" )
SetColorKey   = dllproc( sw,"SetColorKey i=( i color)" )
GetColorKey   = dllproc( sw,"GetColorKey i=()" )

FloodFill     = dllproc( sw,"FloodFill i=( i xPos,i yPos,i crColor,i FillColor)" )
FillEllipse   = dllproc( sw,"FillEllipse i=( i xPos,i yPos,i r1,i r2,i color)" )
Ellipse       = dllproc( sw,"Ellipse i=( i xPos,i yPos,i r1,i r2,i thickness,i color)" )
RoundBox      = dllproc( sw,"RounBox i=( i x1,i y1,i x2,i y2,i r1,i r2,i thickness,i color)" )
FillRoundBox  = dllproc( sw,"FillRoundBox i=( i x1,i y1,i x2,i y2,i r1,i r2,i color)" )
Circle        = dllproc( sw,"Circle i=( i xPos, i yPos,i r1,i thickness,i color)" )
FillCircle    = dllproc( sw,"FillCircle i=( i xPos,i yPos,i r1,i color)" )
Box           = dllproc( sw,"Box i=( i xPos,i yPos,i w,i h,i thickness,i color)" )
FillBox       = dllproc( sw,"FillBox i=( i xPos,i yPos,i w,i h,i color)" )
Line          = dllproc( sw,"Line i=( i xPos,i yPos,i a,i b,i thickness,i color)" )
DrawPoint     = dllproc( sw,"DrawPoint i=( i xPos,i yPos,i width,i height,i color)" )
SetPixel      = dllproc( sw,"SetPixel i=( i xPos,i yPos,i color)" )
GetPixel      = dllproc( sw,"GetPixel i=( i xPos,i yPos)" )
Poke          = dllproc( sw,"Poke i=( i lpMem,offset,c value)" )
wPoke         = dllproc( sw,"wPoke i=( i lpMem,i offset,s value)" )
dPoke         = dllproc( sw,"dPoke i=( i lpMem,i offset,i value)" )
Peek          = dllproc( sw,"Peek c=( i lpMem,i offset) " )
wPeek         = dllproc( sw,"wPeek s=( i lpMem,i offset)" )
dPeek         = dllproc( sw,"dPeek i=( i lpMem,i offset)" )

LoadBmp       = dllproc( sw,"LoadBmp i=(c* bmpFile, i frames)" )
DrawBmp       = dllproc( sw,"DrawBmp i=( i idBmp,i xPos,i yPos,i xZoom,i yZoom,i frames)" )
Sprite        = dllproc( sw,"Sprite i=( i idBmp,i xPos,i yPos,i* frames) " )
BmpText       = dllproc( sw,"BmpText i=( i idBmp,i xPos,i yPos,c* iText, i Zoom,i yZoom)" )
GetBmpPixel   = dllproc( sw,"GetBmpPixel i=( i idBmp,i xPos,i yPos)" )
SetBmpPixel   = dllproc( sw,"SetBmpPixel i=( i idBmp,i xPos,i yPos,i color)" )
GetBmpWidth   = dllproc( sw,"GetBmpWidth i=( i idBmp)" )
GetBmpHeight  = dllproc( sw,"GetBmpHeight i=( i idBmp)" )
RotateBmp     = dllproc( sw,"RotateBmp i=( i idBmp,i xPos,i yPos,f angle)" )
SetBlend      = dllproc( sw,"SetBlend i=( i idBmp,i xPos,i yPos,i width,i height,i alpha)" )
LoadTile      = dllproc( sw,"LoadFile i=(c* tileFile, i rowNumber,i columnNumber)" )
DrawTile      = dllproc( sw,"DrawTile i=( i idTile,i xPos,i yPos,i xZoom,i yZoom,i rowFrame,i columnframe)" )
GetTileWidth  = dllproc( sw,"GetTileWidth i=( i idTile)" )
GetTileHeight = dllproc( sw,"GetTileHeight i=( i idTile)" )
GetWidth      = dllproc( sw,"GetWidth i=() " )
GetHeight     = dllproc( sw,"GetHeight i=() " )

GetValueR     = dllproc( sw,"GetValueR i=( i color)" )
GetValueG     = dllproc( sw,"GetValueG i=( i color)" )
GetValueB     = dllproc( sw,"GetValueB i=( i color)" )
GetValueH     = dllproc( sw,"GetValueH i=( i color)" )
GetValueL     = dllproc( sw,"GetValueL i=( i color)" )
GetValueS     = dllproc( sw,"GetValueS i=( i color)" )
RGB           = dllproc( sw,"RGB i=( i rValue, i gValue, i bValue)" )
HLS           = dllproc( sw,"HLS i=(i hue,i luminance,i saturation)" )

Max           = dllproc( sw,"Max f=(f value1,f value2)" )
Min           = dllproc( sw,"Min f=(f value1,f value2)" )
Sgn           = dllproc( sw,"Sgn f=(f value)" )
BoxColl       = dllproc( sw,"BoxColl i=( i x1,i y1,i w1,i h1,i x2,i y2,i w2,i h2)" )
Wait          = dllproc( sw,"Wait i=( i msec)" )
Rnd           = dllproc( sw,"Rnd i=( i minNumber,i maxNumber)" )
RndF          = dllproc( sw,"RndF f=()" )
Randomize     = dllproc( sw,"Randomize () " )

CloseWindow   = dllproc( sw,"CloseWindow i=()" )
Window        = dllproc( sw,"Window i=( i width,i height,i mode)" )
Sync          = dllproc( sw,"Sync ()" )
Redraw        = dllproc( sw,"Redraw ()" )
Cls           = dllproc( sw,"Cls i=( i color)" )
ScreenHeight  = dllproc( sw,"ScreenHeight i=()" )
ScreenWidth   = dllproc( sw,"ScreenWidth i=()" )
MsgBox        = dllproc( sw,"MsgBox i=(c*text,c*caption, i flag)" )
SetCaption    = dllproc( sw,"SetCaption i=(c* capText)" )
Quit          = dllproc( sw,"Quit i=()" )

GetHandleDC   = dllproc( sw,"GetHandleDC i=()" )
GetHwnd       = dllproc( sw,"GetHwnd i=()" )
GetTileHandle = dllproc( sw,"GetTileHandle i=( i tileIndex)" )
GetBmpHandle  = dllproc( sw,"GetBmpHandle i=( i bmpIndex)" )
 
'Message Flags
IDOK       = 1
IDCANCEL   = 2
IDABORT    = 3
IDRETRY    = 4
IDIGNORE   = 5
IDYES      = 6
IDNO       = 7
IDTRYAGAIN = 10
IDCONTINUE = 11

MB_ICONWARNING  = MB_ICONEXCLAMATION
MB_ICONASTERISK = 0x40
MB_ICONQUESTION = 0x20
MB_ICONHAND     = 0x10
MB_ICONSTOP     = MB_ICONHAND
MB_ICONERROR    = MB_ICONHAND

'Font Flags
DONTCARE  = 100
EXTRALIGHT= 200
LIGHT     = 300
NORMAL    = 400
MEDIUM    = 500
SEMIBOLD  = 600
BOLD      = 700
EXTRABOLD = 800
HEAVY     = 900

'Color
BLUE      = 0xFF0000
DKBLUE    = 0x800000
GREEN     = 0x00FF00
DKGREEN   = 0x008000
CYAN      = 0xFFFF00
RED       = 0x0000FF
DKRED     = 0x000080
MAGENTA   = 0xFF00FF
YELLOW    = 0x00FFFF
DKYELLOW  = 0x008080
WHITE     = 0xFFFFFF
GRAY      = 0x808080
LTGRAY    = 0xC0C0C0
DKGRAY    = 0x404040
LILAC     = 0xFF6699
ROSE      = 0x9C5AEF 
GOLD      = 0x00BDFF
BROWN     = 0x1030B1

'KeyCodes
vk_BACK     = 0x08
vk_TAB      = 0x09 
vk_CLEAR    = 0x0C 
vk_RETURN   = 0x0D 
vk_SHIFT    = 0x10 
vk_CONTROL  = 0x11 
vk_MENU     = 0x12 
vk_PAUSE    = 0x13 
vk_CAPITAL  = 0x14 
vk_ESCAPE   = 0x1B 
vk_SPACE    = 0x20 
vk_PRIOR    = 0x21 
vk_NEXT     = 0x22 
vk_END      = 0x23 
vk_HOME     = 0x24 
vk_LEFT     = 0x25 
vk_UP       = 0x26 
vk_RIGHT    = 0x27 
vk_DOWN     = 0x28 
vk_PRINT    = 0x2A 
vk_SNAPSHOT = 0x2C	 
vk_INSERT   = 0x2D 
vk_DELETE   = 0x2E 
vk_HELP     = 0x2F 

vk_0 = 0x30 
vk_1 = 0x31 
vk_2 = 0x32 
vk_3 = 0x33 
vk_4 = 0x34 
vk_5 = 0x35
vk_6 = 0H36 
vk_7 = 0x37 
vk_8 = 0x38 
vk_9 = 0x39 
vk_@ = 0x40
vk_A = 0x41 
vk_B = 0x42 
vk_C = 0x43 
vk_D = 0x44 
vk_E = 0H45 
vk_F = 0x46 
vk_G = 0x47 
vk_H = 0x48 
vk_I = 0x49 
vk_J = 0x4A 
vk_K = 0x4B
vk_L = 0x4C 
vk_M = 0x4D 
vk_N = 0x4E 
vk_O = 0x4F 
vk_P = 0x50 
vk_Q = 0x51 
vk_R = 0x52 
vk_S = 0x53 
vk_T = 0x54 
vk_U = 0x55 
vk_V = 0x56 
vk_W = 0x57 
vk_X = 0x58 
vk_Y = 0x59 
vk_Z = 0x5A 

vk_F1  = 0x70 
vk_F2  = 0x71 
vk_F3  = 0x72 
vk_F4  = 0x73 
vk_F5  = 0x74 
vk_F6  = 0x75 
vk_F7  = 0x76 
vk_F8  = 0x77 
vk_F9  = 0x78 
vk_F10 = 0x79 
vk_F11 = 0x7A 
vk_F12 = 0x7B 

vk_LSHIFT   = 0xA0 
vk_RSHIFT   = 0xA1 
vk_LCONTR   = 0xA2	 
vk_RCONTROL = 0xA3	
